-- LBP.lua

	
    
		function deepcopy(t)
			if type(t) ~= 'table' then return t end
			local mt = getmetatable(t)
			local res = {}
			for k,v in pairs(t) do
				if type(v) == 'table' then
					v = deepcopy(v)
				end
				res[k] = v
			end
			setmetatable(res,mt)
			return res
		end

-- Variablen
local NameOfProject = "Lazy Boss Preparation"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1;
local LBPMainframe 												-- dummy fuer das Hauptframe
local LBPConfigframe 
local showmode = false;

LBP = {}


LBP_DB = {															-- default Konfiguration,
																		-- wird whrend des Variabelnladens
																		-- ueberschrieben

};


local debugging = false


function LBP.echo( self, msg )												-- Beginn echo
																		-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)

end	

																-- Ende echo

																
	


function LBP.CreateCard( self, parent )

	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "TOP", parent, "BOTTOM", 0, 0, 270, 270)
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
--	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/BUTTONS/WHITE8X8", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	
		
	--local notreadyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
--		notreadyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-NotReady"});
	
	
	
	frame.SpecIcon_frame = LBP:CreateFrame("frame", "Templatecard_SpecIcon", frame, nil, "TOPLEFT", frame, "TOPLEFT", 10, -10, 32, 32)

		frame.SpecIcon = frame.SpecIcon_frame:CreateTexture("SpecIcon")
		frame.SpecIcon:SetTexture("Interface/ICONS/INV_MISC_QUESTIONMARK");
		frame.SpecIcon:SetAllPoints()
		
	frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", frame.SpecIcon, "TOPRIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
	frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)
	
	local editbutton = LBP.CreateCloseButton(self, frame, "Templatecard_editbutton", 24, "TOPRIGHT", frame, "TOPRIGHT", 0, 0)
		--editbutton:SetNormalTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Up")
		editbutton:SetNormalTexture("Interface/GossipFrame/BinderGossipIcon")
			local NormalTexture = editbutton:GetNormalTexture()
		NormalTexture:SetTexCoord(0, 1, 0, 1)
		NormalTexture:ClearAllPoints()
		NormalTexture:SetPoint("TOPLEFT", editbutton, "TOPLEFT", 4, -5)
		NormalTexture:SetPoint("BOTTOMRIGHT", editbutton, "BOTTOMRIGHT", -4, 4)
		editbutton:SetPushedTexture("Interface/GossipFrame/BinderGossipIcon")
		
			local NormalTexture = editbutton:GetPushedTexture()
		NormalTexture:SetTexCoord(0, 1, 0, 1)
		NormalTexture:ClearAllPoints()
		NormalTexture:SetPoint("TOPLEFT", editbutton, "TOPLEFT", 4-1, -5-2)
		NormalTexture:SetPoint("BOTTOMRIGHT", editbutton, "BOTTOMRIGHT", -4-1, 4-2)		
		--editbutton:SetPushedTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Down")
		editbutton:SetScript("OnClick", 
			function(self) 
				LBPConfigframe:SetTemplate(parent.zonetext, parent.subzonetext, parent.id)
				LBPConfigframe:Show()
				LBPConfigframe:Build()
				parent:Hide()
			end)
		
	frame.Talents = {};
	
	local classDisplayName, class, classID = UnitClass("player");
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, frame, nil, "CENTER", frame, "TOPLEFT", mod(a-1,3)*32+26, -ceil(a/3)*32-40,  32, 32)
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()

		frame.Talents[a] = tmpframe;
		frame.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(a, 1, nil, nil, classID); GameTooltip:Show(); end)
		frame.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		--frame.Talents[a]:SetScript("OnMouseUp", function() if PlayerTalentFrame and PlayerTalentFrame:IsVisible() then PlayerTalentFrame_Close() else ToggleTalentFrame() PlayerTalentFrame_Open() end end)
		frame.Talents[a]:SetScript("OnMouseUp", function() ToggleTalentFrame() PlayerTalentFrame_Open() end)
	end

	--frame.prepared
	
	local isSet, shouldbe, a,b, prepared
	
	function frame:CheckTalents()
		prepared = true
		for a = 1,6 do
			for b = 0,2 do
				_, _, _, _, isSet = GetTalentInfo((a-1)*3+b+1)
				shouldbe = tonumber(string.sub(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Talents"],a,a));
				
				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(1);
				frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				frame.Talents[(a-1)*3+b+1]:SetHeight(24)
				frame.Talents[(a-1)*3+b+1]:SetWidth(24)
				
				if b == shouldbe then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,0,0,1);
					frame.Talents[(a-1)*3+b+1]:SetHeight(32)
					frame.Talents[(a-1)*3+b+1]:SetWidth(32)
					
					if not isSet then
						prepared = false
					end
				end
				if isSet then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				end
			end
		end
		
		return prepared
	end
	
		
	local glyphposition = {
		["x"] = {24+4, 0, -24-4, -20-4, 0, 20+4},
		["y"] = {2, 20, 2, -2, -26, -2},
		["point"] = {"BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT", "TOPRIGHT", "TOP", "TOPLEFT" },
		["length"] = {40,48,40,48,40,48},
	}
	
		
	frame.Glyph = {};
	
	for a=1,6 do
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, glyphposition["point"][a], frame, "TOPRIGHT", glyphposition["x"][a]-80, glyphposition["y"][a]-40-32+16-48-20, glyphposition["length"][a], glyphposition["length"][a])
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPGylph"..a)
			
			tmpframe.texture:SetAllPoints()
		tmpframe:SetBackdrop({
				bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			})
			
		tmpframe.icon = "Interface/ICONS/INV_MISC_QUESTIONMARK"
		tmpframe:SetScript("OnMouseUp", function() ToggleTalentFrame(); OpenGlyphFrame() end)
			
		function tmpframe:SetGlyph(icon, tmp)
			
			if tmp then
				tmpframe.texture:SetVertexColor(1,1,1,1);
			else
				tmpframe.texture:SetVertexColor(1,0.2,0.2,1);
			end
			
		
			if tmpframe.texture:GetTexture() == icon then
				return false
			else
				tmpframe.texture:SetTexture(icon)
				return true
			end
		
			
		end
		
		
	frame.Glyph[a] = tmpframe;
	end

	
	local currentGlyphs = LBP:GetGlyphTable();  -- Glyphen die drin sind
	
	local shouldbeicon = {}
	local shouldbeid = {}
	
	local index,value,icon, glyph_id, a, b, drin
	local shouldbe = {}
	

	
	--LBP_DB[zone][subzone][id]["Glyphs"]
	
	function frame:CheckGlyphs()
	
		currentGlyphs = LBP:GetGlyphTable()
		prepared = true;
		
		
		
		for a = 1,6 do
			shouldbe[a] = currentGlyphs[a][2]
		end
		
		
		for c = 1,2 do -- first major, than minor glyphs
		
		-- checks if the current glyph is in the list
		for a = c,6,2 do
			drin = false
			
			for icon, glyph_id in pairs(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)]) do
				if icon == shouldbe[a] then
				
					drin = true
					break
				end
			end
			
			-- if not, goes through the list. if a glyph from the list is not set yet, and sets it

			if not drin then
		
				for icon, glyph_id in pairs(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)]) do
				drin = false
					for b = c,6,2 do
						if icon == shouldbe[b] then
							drin = true
							break
						end
					end
					if not drin then
						shouldbe[a] = icon
						prepared = false
					end
				end
			end
		end
		
		end
		
		for c = 1,2 do
		for a = c,6,2 do
		--print(GetTime())
			if shouldbe[a] == currentGlyphs[a][2] then
				if frame.Glyph[a]:SetGlyph(shouldbe[a], true) then
					frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(currentGlyphs[a][3]); GameTooltip:Show(); end)
					frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				end
			else
				if frame.Glyph[a]:SetGlyph(shouldbe[a], false) then
					frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)][shouldbe[a]]); GameTooltip:Show(); end)
					frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				end
			end
		end
		end
		
	
		return prepared
	end
	


	
	local macro_iconTexture
			
	
	frame.macroframe = {};
	
	for a=1,4 do
		frame.macroframe[a] = LBP:CreateFrame("frame", "Macroframe"..a, frame, nil, "TOPRIGHT", frame, "TOPRIGHT", -10+(a-4)*36, -232+16, 32, 32);
		frame.macroframe[a]:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
		frame.macroframe[a].bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK";
		frame.macroframe[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
	end

	
	
	-- Moonkin opener
	
	local opener = {[1] = "Solar opener", [2] = "Lunar opener", [3] = "Lunar opener at zero"}
		
		
	frame.moonkin = LBP:CreateFrame("frame", "moonkinframe", frame, nil, "TOPLEFT", frame, "BOTTOMRIGHT", -150, 35, 200, 24)	
	
	
	frame.moonkin.texture = frame.moonkin:CreateTexture("OpenerIcon")
		frame.moonkin.texture:SetTexture("Interface/ICONS/INV_MISC_QUESTIONMARK");
		frame.moonkin.texture:SetPoint("TOPLEFT", frame.moonkin, "TOPLEFT", 0, 0)
		frame.moonkin.texture:SetPoint("BOTTOMRIGHT", frame.moonkin, "TOPLEFT", 24, -24)
	
	
	frame.moonkin.text = LBP:CreateFontString(frame.moonkin, "text", "ARTWORK", "GameFontNormal", "LEFT", frame.moonkin, "LEFT", 30, 0, 200, 24, "LEFT", "MIDDLE", 1, 1, 1, 1)
		--editcard.moonkin.text:SetText("Solar opener")
		

		
	frame.moonkin:Hide()
		
-- end / Moonkin opener

		local readyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
		readyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-Ready"});
	
	
	local alpha = 1;
	
	
	local body
		
	function frame:Update()
	
		frame.prepared = true;
	
		if not InCombatLockdown() then
		
			specid, spec, description, icon, background, role = GetSpecializationInfoByID(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Spec"]);
			
			frame.SpecIcon:SetTexture(icon)
	
		
			specid = GetSpecializationInfo(GetSpecialization());
			
			if LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Spec"] == specid then
				frame.TemplateSpec:SetText("|cff00FF00"..spec.."|r");
				frame.SpecIcon:SetDesaturated(0);
				frame.SpecIcon:SetVertexColor(1.0, 1.0, 1.0)
			else
				frame.TemplateSpec:SetText("|cffFF0000"..spec.."|r");
				frame.SpecIcon:SetDesaturated(1);
				frame.SpecIcon:SetVertexColor(1.0, 0.0, 0.0)
				frame.prepared = false;
			end
			
			frame.TemplateName:SetText(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Name"].."\n");

			if not frame:CheckTalents() then
				frame.prepared = false;
			end
		
			if not frame:CheckGlyphs() then
				frame.prepared = false;
			end


			for a=1,4 do
				if not LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] then LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] = "/script print(\"LBP: Macro #"..a.."\")"; end
				
				body = GetMacroBody("LBP Macro "..a)
				
				if body ~= LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] then	
					EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a]) 
					frame.macroframe[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.macroframe[a]); GameTooltip:SetText(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a]); GameTooltip:Show(); end)
				end
			
				_, macro_iconTexture = GetMacroInfo("LBP Macro "..a);
			

				if macro_iconTexture ~= frame.macroframe[a].bgFile then
					frame.macroframe[a]:SetBackdrop({bgFile = macro_iconTexture });
					frame.macroframe[a].bgFile = macro_iconTexture;
				end
			end
				
				
			if LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Spec"] == 102 then
				if not LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["moonkin_opener"] then
					LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["moonkin_opener"] = 1
				end
				frame.moonkin.text:SetText(opener[LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["moonkin_opener"]])
				frame.moonkin:Show()
				
				frame:SetHeight(300)
			else
				frame:SetHeight(260)
				frame.moonkin:Hide()
				
			end
			
				
			if frame.prepared then
				frame:SetBackdropColor(0, 0, 0 , .85)
				--notreadyframe:Hide()
				readyframe:Show()
			else
				frame:SetBackdropColor(.3, 0, 0 , .85)
				readyframe:Hide()
				--notreadyframe:Show()
			end

		end
	end
	

	
	frame:Hide()
	return frame
end



function LBP.CreateWindow(self)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "TOP", UIParent, "CENTER", 0, 350, 220, 50)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/BUTTONS/UI-SliderBar-Border", edgeSize = 4, insets = { left = 0, right = 0, top = 3, bottom = 2 } });
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:Show()
	
	frame.button = LBP.CreateCloseButton(self, frame, "Window_CloseButton", 24, "TOPRIGHT", frame, "TOPRIGHT", -1, -1)
		frame.button:SetScript("OnClick", function(self) frame:Hide() frame:SetAlpha(-2) end)
		
	local alpha = 1
	
	local zonetext = GetZoneText();
	local subzonetext = GetSubZoneText();
	
	frame.zonetext = GetZoneText()
	frame.subzonetext = GetSubZoneText()
	frame.id = nil
	
	
	tinsert(UISpecialFrames,"LBPMainFrame");
	
	frame.prepared = false;
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "CENTER", frame, "CENTER", 0, 0, 220-24-24, 14*3, "CENTER", "MIDDLE", 1, 1, 1, 1)
		textbox:SetText("Zonetext and Subzonetext")

		
	local zone
	local subzone
	--if not frame.zone then frame.zone = GetZoneText() end
	--if not frame.subzone then frame.subzone = GetSubZoneText() end
	
	--frame.cards ={}
	frame.tabs ={}
	
	
	

function frame:CreateTab( parent, zone, subzone, id)

	local card = deepcopy(LBP_DB[zone][subzone][id]);
	
	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "CENTER", parent, "CENTER", 0, 0, 220, 52)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
--	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/ACHIEVEMENTFRAME/UI-Achievement-WoodBorder",tile = false, tileSize = 16, edgeSize = 32, insets = { left = 4, right = 4, top = 4, bottom = 4 } })
	
	
	local specidid, name, description, icon, background, role, class = GetSpecializationInfoByID(LBP_DB[zone][subzone][id]["Spec"])

	
	--frame.SpecIcon = LBP:CreateFrame("frame", "Templatecard_SpecIcon", frame, nil, "TOPLEFT", frame, "TOPLEFT", 10, -10, 32, 32)
			frame.SpecIcon = frame:CreateTexture("Texture")
			frame.SpecIcon:SetTexture(icon)
			frame.SpecIcon:SetDesaturated(1);
			frame.SpecIcon:SetPoint("TOPLEFT", frame, "TOPLEFT", 10, -10)
			frame.SpecIcon:SetPoint("BOTTOMRIGHT", frame, "TOPLEFT", 10+32, -10-32)

		--frame.SpecIcon:SetBackdrop({bgFile = icon });
		--frame.SpecIcon.icon = icon
		
	frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "LEFT", frame.SpecIcon, "RIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
	--frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)

	frame:SetScript("OnMouseUp", function(self)
		for index,value in pairs(LBP_DB[zone][subzone]) do
			value["active"] = false
		end
						
		LBP_DB[zone][subzone][id]["active"] = true;
				
		TimeSinceLastUpdate = 0
		
		for a = 1,4 do
			EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, LBP_DB[zone][subzone][id]["Macro"..a])
		end
		
		LBPMainFrame:Check()
		
	end)



	local spec, icon
		
	function frame:Update()

		_, spec, _, icon = GetSpecializationInfoByID(LBP_DB[zone][subzone][id]["Spec"]);
			
		frame.SpecIcon:SetTexture(icon)
		--if frame.SpecIcon.icon ~= icon then
--			frame.SpecIcon:SetBackdrop({bgFile = icon });
			--frame.SpecIcon.icon = icon
		--end

		--frame.TemplateSpec:SetText("|cff00FF00"..spec.."|r");
		frame.TemplateName:SetText(LBP_DB[zone][subzone][id]["Name"].."\n");
		
		--frame:SetWidth(math.max(frame.TemplateSpec:GetStringWidth(), frame.TemplateName:GetStringWidth())+10+32+10+10)
		--frame:SetWidth(frame.TemplateName:GetStringWidth()+10+32+10+10)
		
	
	end
	
	frame:Hide()
	
	return frame
end


	

	frame.anker = LBP:CreateFrame("frame", "LBPMainFrameAnker", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	local tmpanker = frame.anker;
	--local tmp = LBP:CreateFrame("frame", "tmp", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	
	local n

	local template = LBP:CreateCard( frame, zonetext, subzonetext, index)
		template:ClearAllPoints()
		template:SetPoint("TOP", frame, "BOTTOM", 0, 6)
		template:Show()
	
	
	function frame:BuildTabs()
		for zonetext in pairs(LBP_DB) do
			for subzonetext in pairs(LBP_DB[zonetext]) do
				n = 0;
				for index,value in pairs(LBP_DB[zonetext][subzonetext]) do
					if not frame.tabs[index] then
						frame.tabs[index] = frame:CreateTab( frame, zonetext, subzonetext, index);
						frame.tabs[index]:Hide()
					end
					
					n= n+1;
				end
				if n == 1 then 
					for index in pairs(LBP_DB[zonetext][subzonetext]) do
						LBP_DB[zonetext][subzonetext][index]["active"] = true
					end
				end
			end
		end
	end
	
	
		
	
	
	
	
	function frame:Check()
		
		frame:BuildTabs()
	
		zonetext = GetZoneText();
		subzonetext = GetSubZoneText();
		
		if not InCombatLockdown() then
		
				if frame.zonetext ~= zonetext then
					frame.zonetext = zonetext
					alpha = 1
				end
				if frame.subzonetext ~= subzonetext then
					frame.subzonetext = subzonetext
					alpha = 1
				end
		
		
		
		if LBP_DB[zonetext] and subzonetext then
			if LBP_DB[zonetext][subzonetext] then
				frame:Show()
			else
				frame:Hide()
				return
			end
		else
			frame:Hide()
			return			
		end
		
		
			
			
--			if frame.zone ~= zonetext or frame.subzone ~= subzonetext then
				--frame.zone = zonetext
				--frame.subzone = subzonetext
				
			textbox:SetText(zonetext.."\n"..subzonetext)
				

			

				--for index,value in pairs(frame.cards) do
--					value:Hide()
				--end
				
				for index,value in pairs(frame.tabs) do
					value:Hide()
				end
				
		--if n>0 then
			frame.anker:SetPoint("TOP", template, "BOTTOM", 0,2)
			tmpanker = frame.anker

			
			

		local point, relativeTo, relativePoint, xOffset, yOffset

			
			for index,value in pairs(LBP_DB[zonetext][subzonetext]) do	

				if LBP_DB[zonetext][subzonetext][index]["active"] then
					frame.id = index
					--frame.cards[index]:Show()
					--frame.cards[index]:SetPoint("TOP", frame, "BOTTOM", 0,0)
					template:SetScript("OnMouseUp", function() ToggleTalentFrame(); end)
									
					frame.tabs[index]:Hide()
				else
					frame.tabs[index]:Show()
					
					
					frame.tabs[index]:SetPoint("TOP", tmpanker, "BOTTOM", 0,4)
					tmpanker = frame.tabs[index]
					
					--frame.cards[index]:Hide()
				end
				
				
				
				
			end

		end
	end
	
	--[[
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		frame:Check()
		oldShow(...)
	end
	--]]
	
	
	-- Fade out
	
	frame:SetScript("OnUpdate", function(self)
		if time()-TimeSinceLastUpdate > 0 then
			if alpha == -2 then
				frame:Hide()
				return
			end
			for index in pairs(LBP_DB[zonetext][subzonetext]) do
				if LBP_DB[zonetext][subzonetext][index]["active"] then
					template:Update()

					if alpha < 0 then
						frame:Hide()
						return
					end
					
					if alpha <= 1 then
						if template.prepared then
							alpha = alpha - 0.001
							alpha = alpha - ((1-alpha)^3)/3
						else
							alpha = 1
						end	
					end
					frame:SetAlpha(alpha)	
				else
					alpha = 2
					frame.tabs[index]:Update()
				end
			end
			

			if alpha < 0 then
				--alpha = 1.1
				frame:Hide()
			elseif alpha >= 1 then
				TimeSinceLastUpdate = time()
			end
		end
	
	
	end)
	
	
	
	
	
	
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		--frame:Check()
		TimeSinceLastUpdate = 0;
		oldShow(...)
	end
	
	local oldSetAlpha = frame.SetAlpha;
	
	frame.SetAlpha = function(self, a, ...)
		alpha = a;
		oldSetAlpha(self, a, ...)
	end
	
	
	
	
	
	
	
	
	
	frame:Hide()
	return frame
end


function LBP.GetTalentString(self)
	s = "";
	local c;
	for b = 0,5 do
		c = 3;
		for a = 1,3 do
			local name, iconTexture, tier, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(b*3+a)
			if rank then c = a-1; end
		end
		s = s..c;
	end
	return s
end



local glyphType, icon
local icon2, castSpell
local a,b
local s = {};

function LBP.GetGlyphTable(self)
	for b = 1,6 do
		if not s[b] then s[b] = {} end
		_, glyphType, _, _, icon = GetGlyphSocketInfo(b)
		
		for a=1,GetNumGlyphs() do 
			_, _, _, icon2, castSpell = GetGlyphInfo(a)
			if icon2 == icon then 
				s[b][1] = glyphType
				s[b][2] = icon
				s[b][3] = castSpell
				break 
			end
		end
	end
	return s
end





function LBP.OnEvent( self, event, name, ...)
	if event=="UPDATE_MACROS" then
		if not InCombatLockdown() then
			local numglobal,numperchar = GetNumMacros();
			
			if numglobal > 32 then
				LBP:echo("Not enough space to create the macros. LBP needs four free macro slots")
				EventFrame:UnregisterAllEvents();				
			else
				if not GetMacroInfo("LBP Macro 1") then
					CreateMacro("LBP Macro 1", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #1\")", nil);
				end
				if not GetMacroInfo("LBP Macro 2") then
					CreateMacro("LBP Macro 2", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #2\")", nil);
				end
				if not GetMacroInfo("LBP Macro 3") then
					CreateMacro("LBP Macro 3", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #3\")", nil);
				end
				if not GetMacroInfo("LBP Macro 4") then
					CreateMacro("LBP Macro 4", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #4\")", nil);
				end
			end
		end
	end
	if event=="VARIABLES_LOADED" then
		
		EventFrame:UnregisterEvent("ADDON_LOADED");
				
		EventFrame:SetScript("OnUpdate", 
			function(self, event, ... ) 
				local _, iconTexture = GetTalentInfo(18) 
				if iconTexture then 
				
					EventFrame:SetScript("OnUpdate", nil)
					
					
					LBPMainframe = LBP:CreateWindow();
					LBPConfigframe = LBP:CreateConfig(); 
					local readycheck = LBP:ReadyCheck();
					
					LBPMainframe:Hide()
					LBPConfigframe:Hide()
					
					-- autostart
					
					--LBPConfigframe:SetTemplate("Schrein der Zwei Monde", "Halle des Halbmonds", 1399132532)
					
					--LBPConfigframe:Show()
					--LBPConfigframe:Build()				
					
					
					
	-- neue struktur, diese umwandlung fliegt in ein paar versionen raus				
		for zone in pairs (LBP_DB) do
			for subzone in pairs (LBP_DB[zone]) do
				for id in pairs (LBP_DB[zone][subzone]) do
					if not LBP_DB[zone][subzone][id]["Glyphs"]["1"] then
					
						local bla = {};
						bla["1"] = {};
						bla["2"] = {};
					
					
						for index in pairs (LBP_DB[zone][subzone][id]["Glyphs"]) do

							local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(index)
							
							if icon then
							
							
								local glyphid = 0;
								for a=1,GetNumGlyphs() do 
									local name, glyphType, isKnown, icon2, castSpell,link, subText = GetGlyphInfo(a)
								
									
									if icon2 == icon then glyphid = castSpell break end
								
								end

								bla[tostring(LBP_DB[zone][subzone][id]["Glyphs"][index])][icon] = glyphid;
								
								LBP_DB[zone][subzone][id]["Glyphs"][index] = nil
							end
						end
						LBP_DB[zone][subzone][id]["Glyphs"] = bla
					
					end
				end
			end
		end					
					



		for zone in pairs (LBP_DB) do
			for subzone in pairs (LBP_DB[zone]) do
				for id in pairs (LBP_DB[zone][subzone]) do
					if type(LBP_DB[zone][subzone][id]["Spec"]) == "string" then
						for a = 1,4 do
							local specid, name = GetSpecializationInfo(a)
							if LBP_DB[zone][subzone][id]["Spec"] == name then
								LBP_DB[zone][subzone][id]["Spec"] = specid
							end
						end
					end
				end
			end
		end					
					
					
					
					
					
					
					
					
					
					
					
				end 
			end
		)
		
		
	
		-- Macros

		
--		LBPOnUpdateframe = LBP:CreateFrame("frame", "LBPOnUpdateFrame", UIParent, nil, "TOPLEFT", UIParent, "TOPLEFT", 0, 0, 10, 10)
		--LBPOnUpdateframe:SetScript("OnUpdate", function(self, event, ... ) LBP:OnUpdate(event, ...) end)

	
	
	
	

	
	
	
	
	
	
	end	
	
	
	
	
	
	if not InCombatLockdown() and LBPMainframe and not LBPConfigframe:IsVisible() then
		--LBPMainframe.zone = GetZoneText();
		--LBPMainframe.subzone = GetSubZoneText();
		
		LBPMainframe:Check()	
	end
end											

function LBP.toggle(self, msg)
	if msg == "config" then
		LBPConfigframe:Show()
		LBPConfigframe:Build()
	else
		LBPMainframe:SetAlpha(2) LBPMainframe:Check()
		
		if not LBPMainframe:IsVisible() then
			LBPConfigframe:Show()
			LBPConfigframe:Build()
		end
			
	end
end


function LBP.initialize(self)													-- Beginn initialize

	SlashCmdList["LBP"] = function( msg )  LBP:toggle(strtrim(msg):lower()) end
	SLASH_LBP1 = "/LBP";
	SLASH_LBP1 = "/lbp";
	
	EventFrame = CreateFrame( "Frame", "LBPEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) LBP:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("UPDATE_MACROS");
	EventFrame:RegisterEvent("ZONE_CHANGED");
	EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	EventFrame:RegisterEvent("READY_CHECK");
	--LBPObject = LBPLayoutObj()
	
						
	
	LBP:echo("initialized...")

end	

-- Ende initialize


-- Hilfsfunktionen zum Erstellen von Frames

function LBP.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function LBP.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
		fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		fontstring:SetWidth(width)
		fontstring:SetHeight(height)
		fontstring:SetJustifyH(justifyH)
		fontstring:SetJustifyV(justifyV)
		fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end


function LBP.CreateCloseButton(self, frame, name, width, point, relativeTo, relativePoint, xOffset, yOffset)
	local button = CreateFrame("BUTTON", name, frame, "UIPanelButtonTemplate")
		button:SetWidth(width)
		button:SetHeight(width)
		button:SetNormalTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Up")
		button:SetPushedTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Down")
	
	local NormalTexture = button:GetNormalTexture()
		NormalTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
		NormalTexture:ClearAllPoints()
		NormalTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
		NormalTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	
	local PushedTexture = button:GetPushedTexture()	
		PushedTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
		PushedTexture:ClearAllPoints()
		PushedTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
		PushedTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
		
		
		button:SetScript("OnClick",	function(self) frame.button:GetParent():Hide()	end)
		
		if point and relativeTo and relativePoint and xOffset and yOffset then
			button:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		end
	
	return button
end

LBP.initialize()





